let rec taille = function
| [] ->  0
| t :: q -> 1 + (taille q);;

let rec add l x =
match l with
[] -> x :: []
| t :: q -> if t = x then l else t :: (add q x);;

let rec separe l l1 l2 =
match l with
[] -> (l1, l2)
| [t] -> (t :: l1, l2)
| t :: q :: ll -> (separe ll (t :: l1) (q :: l2));;

let rec fusion l1 l2 =
match (l1, l2) with
  ([], []) -> []
| ([], _) -> l2
| (_, []) -> l1
| (t :: q, r :: s) -> (if t > r then r :: (fusion l1 s) else t :: (fusion q l2));;

let rec trier l =
match l with
[] -> []
| [t] -> [t]
| _ -> let (l1, l2) = (separe l [] []) in (let (a, b) = (trier l1, trier l2) in fusion a b);;

let li = function
[] -> (0, [])
| t :: q -> (t, q);;


let make_tab_of l n =
let resultat = (Array.make n 0) and liste = ref l in
for k = 0 to (n-1) do
let (a, b) = li !liste in
liste := b;
resultat.(k) <- a
done;
resultat;;

let trouver tab x n =
let k = ref 0 and ok = ref false in
while not !ok do
if tab.(!k) = x then ok := true else incr k
done;
!k;;

let make_list_of station correspondances noms =
let cor = correspondances and l = ref [] in
let n = Array.length cor in
for k = 0 to (n-1) do
if cor.(k).(0) = station && cor.(k).(1) <> station then (let a = trouver noms cor.(k).(1) n in l := add !l a);
if cor.(k).(1) = station && cor.(k).(0) <> station then (let a = trouver noms cor.(k).(0) n in l := add !l a)
done;
!l;;



let analyser tabl n no =
let l = ref [] in
for k = 0 to (n-1) do
l := add !l tabl.(k).(0); l := add !l tabl.(k).(1)
done;
let liste = (trier !l) in
let nb = taille liste in
let tab = make_tab_of liste nb in
let resultat = (Array.make nb []) and res = ref 0 in
for k = 0 to (nb-1) do
resultat.(k) <- make_list_of tab.(k) tabl tab;
if tab.(k) = no then res := k
done;

(resultat, !res);;

let rec is_in x = function
[] -> false | t :: q -> (t = x) || (is_in x q);;


let metro tabl nn deb =
let (tab, debut) = (analyser tabl nn deb) in (* pour chaque station ca dit auxquelles elle est relie *)
let n = Array.length tab in
let result = ref 0 in

let rec aux station nb liste =
if (is_in station liste) then () else
(let a = ref tab.(station) in
result := max !result nb;
while !a <> [] do
let (t, q) = li !a in ((aux t (nb+1) (station :: liste)); a := q)
done) in

aux debut 0 [];
(!result - 1);;


(* --------------- *)
(* Entre - Sortie *)

let debut = Scanf.scanf " %d" (fun x->x) in
let nb = Scanf.scanf " %d" (fun x->x) in
let grille = Array.init nb (fun i -> (Scanf.scanf " %d %d" (fun x y -> [| x; y |]))) in
Printf.printf "%d\n" (metro grille nb debut);;